import javax.microedition.lcdui.*;
import java.util.Calendar;
import java.util.Date;

public class timeForm extends Form implements CommandListener {
 midlet midlet;
 Displayable parent;
 DateField [] startPair, endPair;

 public timeForm (midlet midlet, Displayable parent, String hdr) {
  super (hdr);
  this.midlet = midlet;
  this.parent = parent;

  startPair = new DateField[8];
  endPair = new DateField[8]; 
  Calendar cal=Calendar.getInstance();
  Date dt=new Date(0);
  cal.setTime(dt);
  for (int i=0; i<8; i++) {
   startPair[i]=new DateField (midlet.lessonname+" "+(i+1)+" ("+Settings.startStr+")",DateField.TIME);
   endPair[i]=new DateField (midlet.lessonname+" "+(i+1)+" ("+Settings.endStr+")", DateField.TIME);
   String s = midlet.times[i][0];
   cal.set(Calendar.HOUR_OF_DAY,Integer.parseInt(s.substring (0,2)));
   cal.set(Calendar.MINUTE,Integer.parseInt(s.substring (3)));
   dt=cal.getTime();
   startPair[i].setDate(dt);
   append (startPair[i]);
   s = midlet.times[i][1];
   cal.set(Calendar.HOUR_OF_DAY,Integer.parseInt(s.substring (0,2)));
   cal.set(Calendar.MINUTE,Integer.parseInt(s.substring (3)));
   dt=cal.getTime();
   endPair[i].setDate(dt);
   append (endPair[i]);
  }
  addCommand (midlet.Back);
  addCommand (midlet.Save);
 }

 public void show () {
  Display.getDisplay(midlet).setCurrent (this);
  setCommandListener (this);
 }

 public void commandAction (Command c, Displayable d) {
  if (c==midlet.Back) {
   Display.getDisplay(midlet).setCurrent(parent);
  }
  else if (c==midlet.Save) {
   Calendar cal=Calendar.getInstance(); 
   Date d1=new Date(0); 
   cal.setTime(d1);
   int i,h1,m1,h2,m2,pred=0;
   for (i=0; i<8; i++) {
    d1=startPair[i].getDate();
    cal.setTime (d1);
    h1=cal.get (Calendar.HOUR_OF_DAY);
    m1=cal.get (Calendar.MINUTE);
    d1=endPair[i].getDate();
    cal.setTime (d1);
    h2=cal.get (Calendar.HOUR_OF_DAY);
    m2=cal.get (Calendar.MINUTE);
    if (h1*60+m1 >= h2*60+m2) {
     new Message (midlet, this, Settings.errorHeader).show (Settings.badStartEndTimeMessage+(i+1));
     return;
    }
    if (i>0) {
     if (h1*60+m1 <= pred) {
      new Message (midlet, this, Settings.errorHeader).show (Settings.badThisAndNextTimeMessage+(i+1)+", "+i);
      return; 
     }    
    }
    pred=h2*60+m2;
    midlet.times[i][0]=""+midlet.oNum(h1)+":"+midlet.oNum(m1);
    midlet.times[i][1]=""+midlet.oNum(h2)+":"+midlet.oNum(m2);
   }
   midlet.settings_changed=true;
   midlet.updateListHeaders ();
   Display.getDisplay(midlet).setCurrent(parent);
  }
 }

}