import javax.microedition.lcdui.*;

public class pairEditForm extends Form implements CommandListener {
 midlet midlet;
 Displayable parent;
 int cz,dayOfWeek,numZ;
 private TextField numberInput,nameInput,audInput;
 private ChoiceGroup weekDayInput,weekInput;
 int number;
 String name,aud,numdayStr;
 boolean w1,w2, needToDelete = false;
 TextBox editForm;
 int mymode; //0-,1-
 dayForm dayForm = null;
 pairForm pairForm = null;

 public pairEditForm (midlet midlet, Displayable parent, String hdr, int cz, int dayOfWeek, int numZ) {
  super (hdr);
  this.midlet = midlet;
  this.parent = parent;
  this.cz=cz;
  this.dayOfWeek=dayOfWeek;
  this.numZ=numZ;

  numberInput = new TextField (midlet.lessonname, Settings.lastNumber, 1, TextField.NUMERIC);
  String s=midlet.name.elementAt(numZ).toString();
  if (s.length()<1) s=Settings.lastName;
  nameInput = new TextField (Settings.details[0], s, 24, TextField.ANY);
  s=midlet.aud.elementAt(numZ).toString();
  if (s.length()<1) s=Settings.lastAud;
  audInput = new TextField (Settings.details[1], s, 8, TextField.ANY);

  weekDayInput = new ChoiceGroup (Settings.weekDayStr, ChoiceGroup.EXCLUSIVE);
  int selected = -1, k=0;
  for (int i=0; i<7; i++) {
   if (midlet.days[i]>0) {
    weekDayInput.append (Settings.dowStr[i],null);
    if (i+1 == dayOfWeek) selected = k;
    k++;
   }
  }
  if (selected > -1) weekDayInput.setSelectedIndex (selected,true);
   
  weekInput = new ChoiceGroup (Settings.weekNumberStr, ChoiceGroup.MULTIPLE, Settings.czStr, null);
  
  append (numberInput);
  append (nameInput);
  append (audInput);
  append (weekDayInput);
  if (midlet.week12>0) {
   int cz1=Integer.parseInt(midlet.weekZ.elementAt(numZ).toString());
   append (weekInput);
   if (cz1==1) {
    weekInput.setSelectedIndex (0,true);
    weekInput.setSelectedIndex (1,false);
   }
   else if (cz1==2) {
    weekInput.setSelectedIndex (0,false);
    weekInput.setSelectedIndex (1,true);
   }
   else {
    weekInput.setSelectedIndex (0,true);
    weekInput.setSelectedIndex (1,true);
   }
  }

  addCommand (midlet.Back);
  addCommand (midlet.Save);
  if (midlet.type_show>0) addCommand (midlet.SelectType);
  if (midlet.person_show>0) addCommand (midlet.SelectPerson);
  if (midlet.comment_show>0) addCommand (midlet.SetComment);

  editForm = new TextBox (Settings.SetComment,"",256,TextField.ANY);
  editForm.addCommand(midlet.Back);
  editForm.addCommand(midlet.Save);
  editForm.setCommandListener(this);
  mymode=0;
 }

 public pairEditForm (midlet midlet, Displayable parent, String hdr, int cz, int dayOfWeek, int numZ, dayForm dayForm) {
  //  
  this (midlet, parent, hdr, cz, dayOfWeek, numZ);
  this.dayForm = dayForm;
 }

 public pairEditForm (midlet midlet, Displayable parent, String hdr, int cz, int dayOfWeek, int numZ, boolean needToDelete) {
  //  
  this (midlet, parent, hdr, cz, dayOfWeek, numZ);
  this.needToDelete = needToDelete;
 }

 public pairEditForm (midlet midlet, Displayable parent, String hdr, int cz, int dayOfWeek, int numZ, pairForm pairForm) {
  //      pairForm
  this (midlet, parent, hdr, cz, dayOfWeek, numZ);
  this.pairForm = pairForm;
  numberInput.setString (midlet.pairZ.elementAt(numZ).toString());
  nameInput.setString (midlet.name.elementAt(numZ).toString());
  audInput.setString (midlet.aud.elementAt(numZ).toString());
 }


 public void show () {
  Display.getDisplay(midlet).setCurrent (this);
  setCommandListener (this);
 }

 private boolean correctInput () {
  if (numberInput.getString().trim().length()<1) {
   new Message (midlet, this, Settings.errorHeader).show (Settings.voidPairNumberMsg);
   return false;
  }
  number=Integer.parseInt(numberInput.getString());
  if ((number<1) || (number>8)) {
   new Message (midlet, this, Settings.errorHeader).show (Settings.badPairNumberMsg);
   return false;
  }
  name=nameInput.getString().trim();
  if (name.length()<1) {
   new Message (midlet, this, Settings.errorHeader).show (Settings.voidPairNameMsg);
   return false;
  }
  aud=audInput.getString().trim();
  if (aud.length()<1) {
   new Message (midlet, this, Settings.errorHeader).show (Settings.voidAudNameMsg);
   return false;
  }

  if (midlet.week12>0) {
   w1=weekInput.isSelected(0);
   w2=weekInput.isSelected(1);
   if ((w1==false) && (w2==false)) {
    new Message (midlet, this, Settings.errorHeader).show (Settings.weekNotSelectedMsg);
    return false;
   }
   if (w1==true && w2==false) cz=1;
   else if (w1==false && w2==true) cz=2;
   else cz=0;
  }
  else cz=0;

  numdayStr=weekDayInput.getString(weekDayInput.getSelectedIndex());
  for (int i=1; i<8; i++) {
   if (numdayStr.equals(Settings.dowStr[i-1])) {
    dayOfWeek = i;
    break;
   }
  }

  return true;   
 }

 public void delete (int i) {
  midlet.dayZ.removeElementAt(i);
  midlet.weekZ.removeElementAt(i);
  midlet.name.removeElementAt(i);
  midlet.aud.removeElementAt(i);
  midlet.type.removeElementAt(i);
  midlet.pairZ.removeElementAt(i);
  midlet.prep.removeElementAt(i);
  midlet.comment.removeElementAt(i);
  midlet.changed=true;
 }

 public void save () {
  //        ,     
  String st=midlet.times[number-1][0],wk0;
  int i=0;
//System.out.println (midlet.dayZ.size());//!!!
  while (i<midlet.dayZ.size()) {
   if (i!=numZ) {
//System.out.println (midlet.dayZ.elementAt(i).toString()+" "+dayOfWeek);//!!!
    if (midlet.dayZ.elementAt(i).toString().equals(""+dayOfWeek)) {
//System.out.println (Integer.parseInt(midlet.pairZ.elementAt(i).toString())+" "+number);//!!!
     if (Integer.parseInt(midlet.pairZ.elementAt(i).toString())==number) {
      wk0=midlet.weekZ.elementAt(i).toString();
      if ( (midlet.week12<1) || 
           ((wk0.equals("1") || wk0.equals("0")) && (w1==true)) ||
           ((wk0.equals("2") || wk0.equals("0")) && (w2==true))
         ) {
       delete (numZ);
       numZ = i; break;
      }
     }
    }
   }
   i++;
  }

  // 
  midlet.dayZ.setElementAt(""+dayOfWeek,numZ);

  if (midlet.week12>0) {
   if (w1 && w2) midlet.weekZ.setElementAt("0",numZ);
   else if (w1) midlet.weekZ.setElementAt("1",numZ);
   else if (w2) midlet.weekZ.setElementAt("2",numZ);
  }
  else {
   midlet.weekZ.setElementAt("0",numZ);
  }
  midlet.name.setElementAt(name,numZ);
  Settings.lastName = name;
  midlet.aud.setElementAt(aud,numZ);
  Settings.lastAud = aud;
  midlet.pairZ.setElementAt(""+number,numZ);
  Settings.lastNumber = ""+number;

  midlet.changed=true;
  if (dayForm!=null) dayForm.update ();
  if (pairForm!=null) {
   pairForm.numZ = numZ;
   pairForm.cz = cz;
   pairForm.dayOfWeek = dayOfWeek;
   pairForm.update ();
  }
 }

 public void commandAction (Command c, Displayable d) {
  if (c==midlet.Back) {
   if (mymode==0) {
    if (dayForm!=null || needToDelete==true) delete (numZ);
    Display.getDisplay(midlet).setCurrent(parent);
   }
   else {
    mymode=0;
    Display.getDisplay(midlet).setCurrent(this);
   }
  }
  else if (c==midlet.Save) {
   if (mymode==0) {
    if (correctInput()==true) {
     save ();
     //midlet.changed=true;
     midlet.updateListHeaders();   
     Display.getDisplay(midlet).setCurrent(parent);
    }
   }
   else {
    midlet.comment.setElementAt(editForm.getString().trim(),numZ);
    mymode=0;
    midlet.changed=true;
    Display.getDisplay(midlet).setCurrent(this);
   }
  }
  else if (c==midlet.SelectType) {
   listEditor listEditor = new listEditor (midlet, this, Settings.lessonsHeader, midlet.lessons, 1, numZ, midlet.images);
   listEditor.show();
  }
  else if (c==midlet.SelectPerson) {
   listEditor listEditor = new listEditor (midlet, this, Settings.personsHeader, midlet.persons, 0, numZ);
   listEditor.show();
  }
  else if (c==midlet.SetComment) {
   mymode=1;
   editForm.setString (midlet.comment.elementAt(numZ).toString());
   Display.getDisplay(midlet).setCurrent(editForm);
  }
 }

}