import javax.microedition.lcdui.*;

public class pairForm extends Form implements CommandListener {
 midlet midlet;
 Displayable parent;
 public int numZ,cz,dayOfWeek;
 private StringItem[] strRes;
 private Form confirmForm;
 private dayForm dayForm;
 private StringItem msg;

 public void update () {
  strRes[0].setText(midlet.name.elementAt(numZ).toString());
  strRes[1].setText(midlet.aud.elementAt(numZ).toString());

  int j1=Integer.parseInt(midlet.pairZ.elementAt(numZ).toString())-1;
  strRes[2].setText(midlet.times[j1][0]);
  strRes[3].setText(midlet.times[j1][1]);

  if ((midlet.type_show>0) && (midlet.type.elementAt(numZ).toString().length()>0)) {
   strRes[4].setText(midlet.type.elementAt(numZ).toString());
  }
  if (midlet.extra_show>0) {
   String s,s2;
   s=Settings.shortDays[dayOfWeek-1];

   if (midlet.week12>0) {
    int cz=Integer.parseInt(midlet.weekZ.elementAt(numZ).toString());
    if (cz!=0) s+= ", "+ cz+" "+Settings.weekStr;
    else s+=", 1 "+Settings.andStr+" 2 "+Settings.weekStr;
   }

   j1=Integer.parseInt(midlet.pairZ.elementAt(numZ).toString());
   s+= "; " + midlet.lessonname + " " + j1 + "; ";

   s+=Settings.nowStr+" "+midlet.numWeek+" "+Settings.weekStr;
   strRes[5].setText(s);
  }
  if ((midlet.person_show>0) && (midlet.prep.elementAt(numZ).toString().length()>0)) {
   strRes[6].setText(midlet.prep.elementAt(numZ).toString());
  }
  if ((midlet.comment_show>0) && (midlet.comment.elementAt(numZ).toString().length()>0)) {
   strRes[7].setText(midlet.comment.elementAt(numZ).toString());
  }
 }

 public pairForm (midlet midlet, Displayable parent, String hdr,int cz,int dayOfWeek,int numZ, dayForm dayForm) {
  super (hdr);
  this.midlet = midlet;
  this.parent = parent;
  this.cz=cz;
  this.dayOfWeek=dayOfWeek;
  this.numZ=numZ;
  this.dayForm = dayForm;

  strRes = new StringItem[8]; 
  for (int i=0; i<8; i++) {
   strRes[i] = new StringItem(Settings.details[i], null);
  }

  for (int i=0; i<4; i++) append (strRes[i]);
  if (midlet.type_show>0) {
   append (strRes[4]);
  }
  if (midlet.extra_show>0) {
   append (strRes[5]);
  }
  if (midlet.person_show>0) {
   append (strRes[6]);
  }
  if (midlet.comment_show>0) {
   append (strRes[7]);
  }
  update ();

  addCommand (midlet.Back);
  addCommand (midlet.Change);
  addCommand (midlet.Delete);
  addCommand (midlet.DeleteAll);

  confirmForm = new Form (Settings.warningHeader);
  confirmForm.addCommand(midlet.No);
  confirmForm.addCommand(midlet.Yes);
  msg=new StringItem ("",Settings.deleteAllPairsMsg);
  confirmForm.append (msg);
  confirmForm.setCommandListener(this);

 }

 public void show () {
  Display.getDisplay(midlet).setCurrent (this);
  setCommandListener (this);
 }

 public void commandAction (Command c, Displayable d) {
  if (c==midlet.Back) {
   dayForm.update ();
   Display.getDisplay(midlet).setCurrent(parent);
  }
  else if (c==midlet.Change) {
   pairEditForm pairEditForm = new pairEditForm (midlet, this, Settings.pairEditHeader, cz , dayOfWeek, numZ, this);
   pairEditForm.show ();
  }
  else if (c==midlet.Delete) {
   midlet.dayZ.removeElementAt(numZ);
   midlet.weekZ.removeElementAt(numZ);
   midlet.name.removeElementAt(numZ);
   midlet.aud.removeElementAt(numZ);
   midlet.type.removeElementAt(numZ);
   midlet.pairZ.removeElementAt(numZ);
   midlet.prep.removeElementAt(numZ);
   midlet.comment.removeElementAt(numZ);
   midlet.updateListHeaders();
   midlet.changed=true;
   dayForm.update ();
   Display.getDisplay(midlet).setCurrent(parent);
  }
  else if (c==midlet.DeleteAll) {
   Display.getDisplay(midlet).setCurrent(confirmForm);
  }
  else if (c == midlet.Yes) {
   midlet.dayZ.removeAllElements();
   midlet.weekZ.removeAllElements();
   midlet.name.removeAllElements();
   midlet.aud.removeAllElements();
   midlet.type.removeAllElements();
   midlet.pairZ.removeAllElements();
   midlet.prep.removeAllElements();
   midlet.comment.removeAllElements();
   midlet.updateListHeaders();
   midlet.changed=true;    
   dayForm.update ();
   Display.getDisplay(midlet).setCurrent(parent);
  }
  else if (c == midlet.No) {
   Display.getDisplay(midlet).setCurrent(this);
  }
 }

}